package be.syntra.common;

import be.syntra.cowsay.*;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;

@Configuration
@PropertySource("classpath:app.properties")
public class AppConfig {


    @Bean(initMethod ="initLogger")
    public LoggerConfig loggerConfig() { //-> the method name is the "Bean id"
        return new LoggerConfig();
    }


    //define bean for Dao
    @Bean
    public QuoteDao quoteDao() { //-> the method name is the "Bean id"
        return new QuoteDaoMysql();
    }

    //define Bean for swim coach AND dependency injection
    @Bean
    public CowSay cowSay() { //-> the method name is the "Bean id"
        return new OriginalCowSay(quoteDao());
    }

}
